<id>
Print Post Permissions for YaBB 2.6.11
</id>

<version>
0.3
</version>

<mod info>
This mod gives the admin the ability to disable/restrict permission to use Print Post and Print Thread.

Version History
---------------
0.1 - First release - November 13, 2014
0.2 - Print Thread Permissions added - November 22, 2014
0.3 - adapted for 2.6.11 - Jan 5, 2014

Instructions:

Apply the mod and upload (in ASCII mode):

cgi-bin/yabb2/Admin/Modlist.pm
cgi-bin/yabb2/Admin/NewSettings.pm
cgi-bin/yabb2/Admin/Settings_Main.pm
cgi-bin/yabb2/Languages/English/Admin.lng
cgi-bin/yabb2/Sources/Display.pm
cgi-bin/yabb2/Sources/Load.pm
</mod info>

<author>
Dandello
</author>

<homepage>
http://www.yabbforumsoftware.com.net/cgi-bin/yabb2/YaBB.pl
</homepage>

<edit file>
Admin/ModList.pm
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
    $print_post_perms = q~Print Post Permissions for YaBB 2.6.11|Dandello|This mod gives the admin the ability to disable/restrict permission to use Print Post.|0.3|01/05/2015~;
    push @installed_mods, $print_post_perms;
</add before>

<edit file>
Admin/NewSettings.pm
</edit file>

<search for>
1;
EOF
</search for>

<add before>
\$ppostperms = $ppostperms;                  # Sets user permissions to use the Print Post function - Set to 0 to disable, 1 for members, 2 for all users.
\$ptopicperms = $ptopicperms;                  # Sets user permissions to use the Print Thread function - Set to 0 to disable, 1 for members, 2 for all users.
</add before>

<edit file>
Admin/Settings_Main.pm
</edit file>

<search for>
# List of settings
</search for>

<add before>
if    ( !$ppostperms )     { $pp0 = ' selected="selected"'; }
elsif ( $ppostperms == 1 ) { $pp1 = ' selected="selected"'; }
elsif ( $ppostperms == 2 ) { $pp2 = ' selected="selected"'; }
if    ( !$ptopicperms )     { $pt0 = ' selected="selected"'; }
elsif ( $ptopicperms == 1 ) { $pt1 = ' selected="selected"'; }
elsif ( $ptopicperms == 2 ) { $pt2 = ' selected="selected"'; }

</add before>

<search for>
        {
            description => qq~<label for="threadtools">$admin_txt{'528'}</label>~,
</search for>

<add before>
        {
            description => qq~<label for="ppostperms">$admin_txt{'ppostperms'}</label>~,
            input_html => qq~                        <select name="ppostperms" id="ppostperms" size="1">
                        <option value="0"$pp0>$userlevel_txt{'none'}</option>
                        <option value="1"$pp1>$userlevel_txt{'members'}</option>
                        <option value="2"$pp2>$userlevel_txt{'all'}</option>
                        </select>~,
            name => 'ppostperms',
            validate => 'number',
        },
</add before>

<search for>
        {
            description => qq~<label for="user_reason">$admin_txt{'user_reason'}</label>~,
</search for>

<add before>
        {
            description => qq~<label for="ptopicperms">$admin_txt{'ptopicperms'}</label>~,
            input_html => qq~                        <select name="ptopicperms" id="ptopicperms" size="1">
                        <option value="0"$pt0>$userlevel_txt{'none'}</option>
                        <option value="1"$pt1>$userlevel_txt{'members'}</option>
                        <option value="2"$pt2>$userlevel_txt{'all'}</option>
                        </select>~,
            name => 'ptopicperms',
            validate => 'number',
        },
</add before>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
1;
</search for>

<add before>
$admin_txt{'ppostperms'} = q~Print Post Permissions<br /><span class="small">Disable Print Post or set it to "All Members" if you have spambot problems with this function.</span>~;
$admin_txt{'ptopicperms'} = q~Print Thread Permissions<br /><span class="small">Disable Print Thread or set it to "All Members" if you have spambot problems with this function.</span>~;
</add before>

<edit file>
Sources/Display.pm
</edit file>

<search for>
    $template_print =
qq~$menusep<a href="javascript:void(window.open('$scripturl?action=print;num=$viewnum','printwindow'))">$img{'print'}</a>~;
</search for>

<replace>
    if ( ( !$iamguest && $ptopicperms > 0 ) || ( $iamguest && $ptopicperms == 2 ) ) {
        $template_print =
qq~$menusep<a href="javascript:void(window.open('$scripturl?action=print;num=$viewnum','printwindow'))">$img{'print'}</a>~;
    }
</replace>

<search for>
                $template_print_post =
qq~$menusep<a href="javascript:void(window.open('$scripturl?action=print;num=$viewnum;post=$postnum','printwindow'))">$img{'printp'}</a>~;
</search for>

<replace>
            $template_print_post = q{};
            if ( ( !$iamguest && $ppostperms > 0 ) || ( $iamguest && $ppostperms == 2 ) ) {
                $template_print_post =
qq~$menusep<a href="javascript:void(window.open('$scripturl?action=print;num=$viewnum;post=$postnum','printwindow'))">$img{'printp'}</a>~;
            }
</replace>

<edit file>
Sources/Load.pm
</edit file>

<search for>
    foreach my $i ( 0 .. $#buttons ) {
        $tools[$i] = SetImage( $buttons[$i], 3 );
    }
</search for>

<replace>
    foreach my $i ( 0 .. $#buttons ) {
        if ( $buttons[$i] eq 'printp' && ( !$ppostperms || ( $iamguest && $ppostperms < 2 ) ) || $buttons[$i] eq 'print' && ( !$ptopicperms || ( $iamguest && $ptopicperms < 2 ) ) ) {
            $buttons[$i] = q{};
            $tools[$i] = q{};
        }
        else {
            $tools[$i] = SetImage( $buttons[$i], 3 );
        }
    }
</replace>